#include	<stdlib.h>
#include	<string.h>

#include	"splitter.h"

char **split(char *str, const char *delim, register int elem, register int rep) {
    char ** dest = NULL;
    return split_r(str, delim, &dest, elem, rep);
}

char **split_r(char *str, const char *delim, char ***dest, register int elem, register int rep) {
    register int i=0, num, ind=0;
    int j=0, start=0;
    register int len=0;
    char **strdest = *dest;

    if(str)
	len=strlen(str);
    else 
	return NULL;
	
    if (elem == SPLIT_INFINITE){
	num = 3;
    }
    else {
	num = elem;
    }
    strdest = malloc((sizeof (char *)) * (num + 1));
    memset(strdest, '\0', (sizeof (char *)) * (num + 1));
	
    while (i < len) {
	while ((num-1 > 0) && (i < len)) {
	    while (delim[j] != '\0'){
		if(str[i] == delim[j]) {
		    strdest[ind] = malloc(i-start + 1);
		    memset(strdest[ind],'\0',i-start + 1);
		    memcpy(strdest[ind], str+start, (i-start));
		    strdest[ind][i-start] = '\0';
		    ind++;
		    num--;
		    start = i+1;
		    if(rep == SPLIT_NOREPEAT) {
			break;
		    }
		    i++;
		    j = 0;
		    while (delim[j] != '\0') {
			if (str[i] == delim[j]){
			    i++;
			    if (str[i] == '\0') {
				return (strdest);
			    }
			    start = i;
			    j = 0;
			    continue;
			}
			j++;
		    }
		    j = 0;
		}
		j++;
	    }
	    i++;
	    j = 0;
	}
	if (elem != SPLIT_INFINITE) {
	    break;
	}
	num = 3;
	strdest = realloc(strdest, sizeof(char *) * (num + ind + 2));
    }
	
    if (num <= 1) {
	i = strlen(str);
    }
		
    strdest[ind]  =malloc(i-start + 1);
    memset(strdest[ind], '\0', i-start + 1);
    memcpy(strdest[ind], str + start, (i - start));
    strdest[ind][i-start] = '\0';
    ind++;
    strdest = realloc(strdest, sizeof(char *) * (ind + 1));
    strdest[ind] = NULL;
    return(strdest);
}

void split_free(char ** data){
    int i = 0;
    if (data){
	while(data[i]){
	    free(data[i]);
	    i++;
	}    
	free(data);
    }
}
